Package net.sf.saxon.query

## Class XQueryFunction

- java.lang.Object
- - net.sf.saxon.query.XQueryFunction

- All Implemented Interfaces:
    `javax.xml.transform.SourceLocator`, `Declaration`, `Location`, `org.xml.sax.Locator`

      public class XQueryFunction
      extends java.lang.Object
      implements Declaration, Location

  A user-defined function in an XQuery module

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XQueryFunction()` | Create an XQuery function

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addArgument​(UserFunctionParameter argument)` | Add an argument to the list of arguments
    `void` | `checkReferences​(ExpressionVisitor visitor)` | Type-check references to this function
    `void` | `compile()` | Compile this function to create a run-time definition that can be interpreted (note, this has nothing to do with Java code generation)
    `void` | `explain​(ExpressionPresenter out)` | Produce diagnostic output showing the compiled and optimized expression tree for a function
    `void` | `fixupReferences()` | Fix up references to this function
    `AnnotationList` | `getAnnotations()` | Get the annotations defined on this function
    `SequenceType[]` | `getArgumentTypes()` | Get the declared types of the arguments of this function
    `Expression` | `getBody()` | Get the body of the function
    `int` | `getColumnNumber()` | Return the column number
    `java.lang.String` | `getDisplayName()` | Get the name of the function for display in error messages
    `StructuredQName` | `getFunctionName()` | Get the name of the function as a structured QName
    `HostLanguage` | `getHostLanguage()` | Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
    `SymbolicName` | `getIdentificationKey()` | Get an identifying key for this function, which incorporates the URI and local part of the function name plus the arity
    `static SymbolicName` | `getIdentificationKey​(StructuredQName qName, int arity)` | Construct what the identification key would be for a function with given URI, local name, and arity
    `int` | `getLineNumber()` | Get the line number of the instruction in the source stylesheet module.
    `NamespaceResolver` | `getNamespaceResolver()` | Get the namespace context of the instruction.
    `int` | `getNumberOfArguments()` | Get the arity of the function
    `StructuredQName` | `getObjectName()` | Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `PackageData` | `getPackageData()` | Get data about the unit of compilation (XQuery module, XSLT package) to which this container belongs
    `UserFunctionParameter[]` | `getParameterDefinitions()` | Get the definitions of the arguments to this function
    `java.util.Iterator<java.lang.String>` | `getProperties()` | Get an iterator over all the properties available.
    `java.lang.Object` | `getProperty​(java.lang.String name)` | Get the value of a particular property of the instruction.
    `java.lang.String` | `getPublicId()` | Return the public identifier for the current document event.
    `SequenceType` | `getResultType()` | Get the result type of the function
    `StaticContext` | `getStaticContext()` | Get the static context for this function
    `java.lang.String` | `getSystemId()` | Get the system identifier (URI) of the source module containing the instruction.
    `UserFunction` | `getUserFunction()` | Get the callable compiled function contained within this XQueryFunction definition.
    `boolean` | `hasAnnotation​(StructuredQName name)` | Ask whether the function has an annotation with a particular name
    `boolean` | `isMemoFunction()` | Find out whether this is a memo function
    `boolean` | `isPrivate()` | Ask whether this is a private function (as defined in XQuery 3.0)
    `boolean` | `isUpdating()` | Ask whether this is an updating function (as defined in XQuery Update)
    `void` | `optimize()` | Optimize the body of this function
    `void` | `registerReference​(UserFunctionResolvable ufc)` | Register a call on this function
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setAnnotations​(AnnotationList annotations)` | Set the annotations on this function
    `void` | `setBody​(Expression body)` | Set the body of the function
    `void` | `setFunctionName​(StructuredQName name)` | Set the name of the function
    `void` | `setLocation​(Location location)` | Set the location of the source declaration of the function
    `void` | `setMemoFunction​(boolean isMemoFunction)` | Set that this is, or is not, a memo function.
    `void` | `setResultType​(SequenceType resultType)` | Set the required result type of the function
    `void` | `setStaticContext​(QueryModule env)` | Set the static context for this function
    `void` | `setUpdating​(boolean isUpdating)` | Set whether this is an updating function (as defined in XQuery Update)

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XQueryFunction

          public XQueryFunction()

      Create an XQuery function

  - ### Method Detail

    - #### getPackageData

          public PackageData getPackageData()

      Get data about the unit of compilation (XQuery module, XSLT package) to which this container belongs

    - #### setFunctionName

          public void setFunctionName​(StructuredQName name)

      Set the name of the function
      Parameters:
        `name` - the name of the function as a StructuredQName object

    - #### addArgument

          public void addArgument​(UserFunctionParameter argument)

      Add an argument to the list of arguments
      Parameters:
        `argument` - the formal declaration of the argument to be added

    - #### setResultType

          public void setResultType​(SequenceType resultType)

      Set the required result type of the function
      Parameters:
        `resultType` - the declared result type of the function

    - #### setBody

          public void setBody​(Expression body)

      Set the body of the function
      Parameters:
        `body` - the expression forming the body of the function

    - #### getBody

          public Expression getBody()

      Get the body of the function
      Returns:
        the expression making up the body of the function

    - #### setLocation

          public void setLocation​(Location location)

      Set the location of the source declaration of the function
      Parameters:
        `location` - the source location

    - #### getFunctionName

          public StructuredQName getFunctionName()

      Get the name of the function as a structured QName
      Returns:
        the name of the function as a structured QName

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the name of the function for display in error messages
      Returns:
        the name of the function as a lexical QName

    - #### getIdentificationKey

          public SymbolicName getIdentificationKey()

      Get an identifying key for this function, which incorporates the URI and local part of the function name plus the arity
      Returns:
        an identifying key

    - #### getIdentificationKey

          public static SymbolicName getIdentificationKey​(StructuredQName qName,
                                                          int arity)

      Construct what the identification key would be for a function with given URI, local name, and arity
      Parameters:
        `qName` - the name of the function
        `arity` - the number of arguments
      Returns:
        an identifying key

    - #### getResultType

          public SequenceType getResultType()

      Get the result type of the function
      Returns:
        the declared result type

    - #### setStaticContext

          public void setStaticContext​(QueryModule env)

      Set the static context for this function
      Parameters:
        `env` - the static context for the module in which the function is declared

    - #### getStaticContext

          public StaticContext getStaticContext()

      Get the static context for this function
      Returns:
        the static context for the module in which the function is declared

    - #### getArgumentTypes

          public SequenceType[] getArgumentTypes()

      Get the declared types of the arguments of this function
      Returns:
        an array, holding the types of the arguments in order

    - #### getParameterDefinitions

          public UserFunctionParameter[] getParameterDefinitions()

      Get the definitions of the arguments to this function
      Returns:
        an array of UserFunctionParameter objects, one for each argument

    - #### getNumberOfArguments

          public int getNumberOfArguments()

      Get the arity of the function
      Returns:
        the arity (the number of arguments)

    - #### registerReference

          public void registerReference​(UserFunctionResolvable ufc)

      Register a call on this function
      Parameters:
        `ufc` - a user function call that references this function.

    - #### setMemoFunction

          public void setMemoFunction​(boolean isMemoFunction)

      Set that this is, or is not, a memo function. A memo function remembers the results of calls on the function so that the a subsequent call with the same arguments simply look up the result
      Parameters:
        `isMemoFunction` - true if this is a memo function.

    - #### isMemoFunction

          public boolean isMemoFunction()

      Find out whether this is a memo function
      Returns:
        true if this is a memo function

    - #### setUpdating

          public void setUpdating​(boolean isUpdating)

      Set whether this is an updating function (as defined in XQuery Update)
      Parameters:
        `isUpdating` - true if this is an updating function

    - #### isUpdating

          public boolean isUpdating()

      Ask whether this is an updating function (as defined in XQuery Update)
      Returns:
        true if this is an updating function

    - #### setAnnotations

          public void setAnnotations​(AnnotationList annotations)

      Set the annotations on this function
      Parameters:
        `annotations` - the annotations, indexed by annotation name

    - #### getAnnotations

          public AnnotationList getAnnotations()

      Get the annotations defined on this function
      Returns:
        the list of annotations defined on this function

    - #### hasAnnotation

          public boolean hasAnnotation​(StructuredQName name)

      Ask whether the function has an annotation with a particular name
      Parameters:
        `name` - the name of the required annotation

    - #### isPrivate

          public boolean isPrivate()

      Ask whether this is a private function (as defined in XQuery 3.0)
      Returns:
        true if this is a private function

    - #### compile

          public void compile()
                       throws XPathException

      Compile this function to create a run-time definition that can be interpreted (note, this has nothing to do with Java code generation)
      Throws:
        `XPathException` - if errors are found

    - #### optimize

          public void optimize()
                        throws XPathException

      Optimize the body of this function
      Throws:
        `XPathException` - if execution fails, for example because the function is updating and contains constructs not allowed in an updating function, or vice-versa.

    - #### fixupReferences

          public void fixupReferences()

      Fix up references to this function

    - #### checkReferences

          public void checkReferences​(ExpressionVisitor visitor)
                               throws XPathException

      Type-check references to this function
      Parameters:
        `visitor` - the expression visitor
      Throws:
        `XPathException`

    - #### explain

          public void explain​(ExpressionPresenter out)
                       throws XPathException

      Produce diagnostic output showing the compiled and optimized expression tree for a function
      Parameters:
        `out` - the destination to be used
      Throws:
        `XPathException`

    - #### getUserFunction

          public UserFunction getUserFunction()

      Get the callable compiled function contained within this XQueryFunction definition.
      Returns:
        the compiled function object

    - #### getObjectName

          public StructuredQName getObjectName()

      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the system identifier (URI) of the source module containing the instruction. This will generally be an absolute URI. If the system identifier is not known, the method may return null. In some cases, for example where XML external entities are used, the correct system identifier is not always retained.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the system ID, or null if the information is not available.

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the instruction in the source stylesheet module. If this is not known, or if the instruction is an artificial one that does not relate to anything in the source code, the value returned may be -1.
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number, or -1 if the information is not available.

    - #### getPublicId

          public java.lang.String getPublicId()

      Return the public identifier for the current document event.
      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        A string containing the public identifier, or null if none is available.
      See Also:
        `getSystemId()`

    - #### getColumnNumber

          public int getColumnNumber()

      Return the column number
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        The column number, or -1 if none is available.
      See Also:
        `getLineNumber()`

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### getNamespaceResolver

          public NamespaceResolver getNamespaceResolver()

      Get the namespace context of the instruction. This will not always be available, in which case the method returns null.

    - #### getProperty

          public java.lang.Object getProperty​(java.lang.String name)

      Get the value of a particular property of the instruction. Properties of XSLT instructions are generally known by the name of the stylesheet attribute that defines them.
      Parameters:
        `name` - The name of the required property
      Returns:
        The value of the requested property, or null if the property is not available

    - #### getProperties

          public java.util.Iterator<java.lang.String> getProperties()

      Get an iterator over all the properties available. The values returned by the iterator will be of type String, and each string can be supplied as input to the getProperty() method to retrieve the value of the property.

    - #### getHostLanguage

          public HostLanguage getHostLanguage()

      Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
      Returns:
        `HostLanguage.XQUERY`